import java.util.*;
 
import javax.persistence.*;
 
 
public class F380 {
 
    static EntityManagerFactory emf =
            Persistence.createEntityManagerFactory(
                "objectdb:db/test.tmp;drop");
      static  EntityManager em = emf.createEntityManager();
	
	
    public static void main(String[] args) {
 
        Folder f = new Folder("A");
        Link l = new Link();
        l.setName("A");
        l.setUrl("B");
        f.addChild(l);
 
        em.getTransaction().begin();
        em.persist(f);
        em.getTransaction().commit();
 
        List<Folder> folders = findFolderByName("A");
		System.out.println("Loaded folders:" + folders);
		for (Entry ff: folders) {
			System.out.println(ff.getName() + " " + ff.getClass().getCanonicalName());
		}
      
        em.close();
        emf.close();
        System.out.println("Done");
    }
 
	public static List<Folder> findFolderByName(String folderName) {
		TypedQuery<Folder> byNameQuery = em.createQuery("SELECT f FROM Entry f WHERE f.name=:name", Folder.class); 
		return byNameQuery.setParameter("name", folderName).getResultList();
	}

}
